# Contains PARAMETERS

import os
# System constrain: number of households should be larger than number of families
# System constrain: number of members in a family is determined by the average ratio of inputs #agents #families

# OUTPUT DATA #########################################################################################################
# Change your output directory as necessary
OUTPUT_PATH = 'C:/Users/r1702898/Documents/Modelagem/MeusModelos/Resultados/Resultados_temp'
# OUTPUT_PATH = '//STORAGE4/carga/MODELO DINAMICO DE SIMULACAO/Exits_python/'

# RUN PARAMETERS ######################################################################################################

TOTAL_DAYS = 5040                        # A good number is 5040. 20 years
TOTAL_AGENTS = 1000                        # We have been trying from 1000 to 10,000
TOTAL_FAMILIES = 400                      # Endogenous average family size. We suggest a 2.5 members per family
TOTAL_HOUSEHOLDS = 440                     # Necessarily higher than number of families
TOTAL_FIRMS = 110                             # Roughly around 11% of total number of agents
NUMBER_REGIONS = 7

# PARAMETERS ##########################################################################################################
# FIRMS
# Key parameters
ALPHA = .35
                                 # Production function, labour with decaying exponent, Alpha for K. [0, 1]
BETA = .6                                 # Consumption function, beta. Decaying consumption on wealth
QUANTITY_TO_CHANGE_PRICES = 200            # Quantity considered exceeding/LACKING in inventory,
                                            # triggers change in prices
MARKUP = 0.03             # By how much to reduce/increase prices, given high stock

LABOUR_MARKET = 0.25

# AGENTS
SIZE_MARKET = 10
CONSUMPTION_SATISFACTION = 0.01               # Satisfaction to increase utility by amount consumed

# HOUSEHOLDS
PERCENTAGE_CHECK_NEW_LOCATION = 0.05        # Percentage of households pursuing new location

# GOVERNMENT
TAX_CONSUMPTION = .3                      # Charged from firms, percentage of price sold per one unit

########################################################################################################################
# Class to facilitate printing ########################################################################################
class Parameters():
    def __init__(self, QUANTITY_TO_CHANGE_PRICES,MARKUP,
                 ALPHA, BETA, TOTAL_DAYS, TOTAL_AGENTS, TOTAL_FAMILIES,
                 TOTAL_HOUSEHOLDS, TOTAL_FIRMS):
        # Firms
        self.QUANTITY_TO_CHANGE_PRICES = QUANTITY_TO_CHANGE_PRICES
        self.MARKUP = MARKUP
        self.ALPHA = ALPHA
        self.BETA = BETA
        # Utility
        self.CONSUMPTION_SATISFACTION = CONSUMPTION_SATISFACTION
        # Household
        self.PERCENTAGE_CHECK_NEW_LOCATION = PERCENTAGE_CHECK_NEW_LOCATION
        # Government
        self.TAX_CONSUMPTION = TAX_CONSUMPTION
        # Run parameters
        self.TOTAL_DAYS = TOTAL_DAYS
        self.TOTAL_AGENTS = TOTAL_AGENTS
        self.TOTAL_FAMILIES = TOTAL_FAMILIES
        self.TOTAL_HOUSEHOLDS = TOTAL_HOUSEHOLDS
        self.TOTAL_FIRMS = TOTAL_FIRMS
        self.NUMBER_REGIONS = NUMBER_REGIONS
        self.SIZE_MARKET = SIZE_MARKET

    def get_TOTAL_DAYS(self):
        return self.TOTAL_DAYS

    def get_TOTAL_AGENTS(self):
        return self.TOTAL_AGENTS

    def get_TOTAL_FAMILIES(self):
        return self.TOTAL_FAMILIES

    def get_TOTAL_HOUSEHOLDS(self):
        return self.TOTAL_HOUSEHOLDS

    def get_TOTAL_FIRMS(self):
        return self.TOTAL_FIRMS

    def get_QUANTITY_TO_CHANGE_PRICES(self):
        return self.QUANTITY_TO_CHANGE_PRICES

    def get_MARKUP(self):
        return self.MARKUP

    def get_ALPHA(self):
        return self.ALPHA

    def get_BETA(self):
        return self.BETA

    def get_CONSUMPTION_SATISFACTION(self):
        return self.CONSUMPTION_SATISFACTION

    def get_PERCENTAGE_CHECK_NEW_LOCATION(self):
        return self.PERCENTAGE_CHECK_NEW_LOCATION

    def get_TAX_CONSUMPTION(self):
        return self.TAX_CONSUMPTION

    def get_SIZE_MARKET(self):
        return self.SIZE_MARKET

    def get_NUMBER_REGIONS(self):
        return self.NUMBER_REGIONS

    def __str__(self):
        return 'Alpha: %s, Price change perc. %s' % \
               (self.ALPHA, self.MARKUP)

my_parameters = Parameters(QUANTITY_TO_CHANGE_PRICES, MARKUP, ALPHA, BETA, TOTAL_DAYS, TOTAL_AGENTS, TOTAL_FAMILIES,
                           TOTAL_HOUSEHOLDS, TOTAL_FIRMS)
# Defining the path and name of output data based in parameters used to run the model

parameters_names = '_%s_%s_%s_%s_%s_%s_%s_%s_%s_%s_%s_%s_%s_%s_%s' % (TOTAL_DAYS,TOTAL_AGENTS, TOTAL_FAMILIES,
                                                                      TOTAL_HOUSEHOLDS, TOTAL_FIRMS, NUMBER_REGIONS,
                                                                      SIZE_MARKET, ALPHA, BETA,
                                                                      QUANTITY_TO_CHANGE_PRICES, MARKUP, LABOUR_MARKET,
                                                                      CONSUMPTION_SATISFACTION,
                                                                      PERCENTAGE_CHECK_NEW_LOCATION, TAX_CONSUMPTION)

firms_data = os.path.join(OUTPUT_PATH,  "temp_firm%s.txt"%parameters_names)
agents_data = os.path.join(OUTPUT_PATH, "temp_agent%s.txt"%parameters_names)
houses_data = os.path.join(OUTPUT_PATH, "temp_house%s.txt"%parameters_names)
general_data = os.path.join(OUTPUT_PATH, "temp_general%s.txt"%parameters_names)
quality_data = os.path.join(OUTPUT_PATH, "temp_quality%s.txt"%parameters_names)
region_data = os.path.join(OUTPUT_PATH, "temp_region%s.txt"%parameters_names)
